HDU 5795 A Simple Nim 打表求SG函数的规律

A Simple Nim

Problem Description
 
Two players take turns picking candies from n heaps,the player who picks the last one will win the game.On each turn they can pick any number of candies which come from the same heap(picking no candy is not allowed).To make the game more interesting,players can separate one heap into three smaller heaps(no empty heaps)instead of the picking operation.Please find out which player will win the game if each of them never make mistakes.
 
Input
 
Intput contains multiple test cases. The first line is an integer 1T100, the number of test cases. Each case begins with an integer n, indicating the number of the heaps, the next line contains N integers s[0],s[1],....,s[n1], representing heaps with s[0],s[1],...,s[n1] objects respectively.(1n106,1s[i]109)
 
Output
 
For each test case,output a line whick contains either"First player wins."or"Second player wins".
 
Sample Input
 
2 2 4 4 3 1 2 4
 
Sample Output
 
Second player wins. First player wins.
 
题意:
  给你n堆糖果
  A,B两个人可以像nim游戏那样,在一堆中取任意个糖果
  但是此题新增了, 玩家可以将一堆糖果分成三个非空堆,并且不取
  最后取完的胜利;
题解:
  像这种暴力求SG函数会超时的
  咋们就打表找规律
  打表程序已给出,规律你就自己找吧
#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>
using namespace std;
#pragma comment(linker, "/STACK:102400000,102400000")
#define ls i<<1
#define rs ls | 1
#define mid ((ll+rr)>>1)
#define pii pair<int,int>
#define MP make_pair
typedef long long LL;
const long long INF = 1e18+1LL;
const double Pi = acos(-1.0);
const int N = 5e5+10, M = 2e5+20, mod = 1e9+7, inf = 2e9;

int sg[N],vis[N];
int main() {
        /*sg[0] = 0;
        for(int i = 1; i <= 100; ++i) {
            memset(vis,0,sizeof(vis));
            for(int j = 0; j < i; ++j) vis[sg[j]] = 1;
            for(int j = 1; j <= i; ++j){
                for(int jj = 1; jj <= i; ++jj) {
                    for(int k = 1; k <= i; ++k) {
                        if(j + jj + k == i) {
                            vis[sg[j] ^ sg[jj] ^ sg[k]] = 1;
                        }
                    }
                }
            }
            for(int j = 0; j <= 1000; ++j) {
                if(!vis[j]) {
                    sg[i] = j;
                    break;
                }
            }
            cout<<i<<": " << sg[i]<<endl;
        }
        */
        int T,n,x;
        scanf("%d",&T);
        while(T--) {
            scanf("%d",&n);
            int ans = 0;
            for(int i = 1; i <= n; ++i) {
                scanf("%d",&x);
                if((x+1)%8 == 0) {
                    ans ^= (x+1);
                } else if(x % 8 == 0) ans ^= (x-1);
                else ans ^= x;
            }
            if(!ans) puts("Second player wins.");else puts("First player wins.");

        }
        return 0;
}
原文地址:https://www.cnblogs.com/zxhl/p/6011293.html